package Main;

import javax.swing.*;
import java.awt.*;
import java.util.List;
import javax.swing.Timer;
import java.awt.event.*;
import GeneratedCode.*;
import Type.*;
import BuiltIns.*;

class Animation extends JPanel implements ActionListener{

	static int timeElapsed = 0;
	static int WIDTH = 640;
	static int HEIGHT = 480;

/* Make a blank panel with the given size */
	public Animation() {
		super();
		setSize(WIDTH, HEIGHT);
		setVisible(true);
		setDoubleBuffered(true);
	}

/* Draw all the figures; if they're not built-in, do it recursicvely */
	public void draw(Graphics g){
		for (Figure f : Figures.figures)	{
			if ((f instanceof TextFigure) || (f instanceof RectFigure) || (f instanceof PolyFigure) || (f instanceof ArcFigure)) {
				f.draw(g);
			}
			else {
			    for (Figure s : f.components) {
				s.draw(g);
			    }
			}
		}
	}

/* Overriding the JPanel paint method to also draw figures */
	public void paint(Graphics g) {
		super.paint(g);
		draw(g);
	}

/* Timer updates every 1 ms and then calls the panel itself as a listener */
	public void run() {
		Timer animator = new Timer(1, this);
		animator.start();
	}

/* Every ms update the time elapsed and update animating figures */
	public void actionPerformed(ActionEvent e) {
		++timeElapsed;
		for (Figure f : Figures.figures) {
			if (f._animating) {
				f._update.call(new IntType(timeElapsed));
			}
		}
		repaint();
	}

	public static void main(String[] args) {
		GeneratedMain.generatedMain();

		JFrame holder = new JFrame("Animation");
		holder.setVisible(true);
		holder.setSize(WIDTH, HEIGHT);
		holder.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Animation proj = new Animation();
		holder.add(proj);

		proj.run();
	}
}
